/*
 * Created on: Jul 29, 2024
 *
 * not sure how well the ambient light sensor will work, being surrounded by other LEDs.
 * I guess I could make the programs black out and read then. maybe I'll do that.
 */

#include <ch32v20x.h>

#include "adc.h"



static GPIO_InitTypeDef lsens_gpio = {
        .GPIO_Mode = GPIO_Mode_Out_PP,
        .GPIO_Pin = LSENS_A_PIN | LSENS_K_PIN,
        .GPIO_Speed = GPIO_Speed_2MHz
};

uint16_t lsens_val;
static uint8_t lsens_mode = LSENS_READING_IDLE;



void adc_init()
{
    ADC_InitTypeDef  adc = {0};

    RCC_ADCCLKConfig(RCC_PCLK2_Div4);

    ADC_DeInit(ADC1);
    adc.ADC_Mode = ADC_Mode_Independent;
    adc.ADC_ScanConvMode = DISABLE;
    adc.ADC_ContinuousConvMode = DISABLE;
    adc.ADC_ExternalTrigConv = ADC_ExternalTrigConv_None;
    adc.ADC_DataAlign = ADC_DataAlign_Right;
    adc.ADC_NbrOfChannel = 1;
    ADC_Init(ADC1, &adc);

    ADC_RegularChannelConfig(ADC1, LSENS_ADC_CH, 1, ADC_SampleTime_239Cycles5);
    ADC_Cmd(ADC1, ENABLE);
}

void adc_convert()
{
    ADC_SoftwareStartConvCmd(ADC1, ENABLE);
}

void adc_read()
{
    while(!ADC_GetFlagStatus(ADC1, ADC_FLAG_EOC));
    lsens_val = ADC_GetConversionValue(ADC1);
}

void adc_set_mode_lsens(uint8_t mode)
{
    lsens_mode = mode;

    // always reconfigure the pins as outputs when calling this
    lsens_gpio.GPIO_Pin = LSENS_A_PIN | LSENS_K_PIN;
    lsens_gpio.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_Init(LSENS_PORT, &lsens_gpio);

}

uint8_t adc_get_mode_lsens()
{
    return lsens_mode;
}

static void lsens_start()
{
    // set anode and cathode low
    LSENS_PORT->BCR = LSENS_A_PIN | LSENS_K_PIN;

    adc_set_mode_lsens(LSENS_READING_START);

    // set cathode high, let it charge
    LSENS_PORT->BSHR = LSENS_K_PIN;

    // set anode floating
    lsens_gpio.GPIO_Pin = LSENS_A_PIN;
    lsens_gpio.GPIO_Mode = GPIO_Mode_IPD;
    GPIO_Init(LSENS_PORT, &lsens_gpio);

    // set cathode as analog input
    lsens_gpio.GPIO_Pin = LSENS_K_PIN;
    lsens_gpio.GPIO_Mode = GPIO_Mode_AIN;
    GPIO_Init(LSENS_PORT, &lsens_gpio);
}

static void lsens_end()
{
    adc_set_mode_lsens(LSENS_READING_IDLE);
}

void adc_process_lsens(uint8_t convert)
{
    if (lsens_mode != LSENS_OUTPUT) {
        // do what needs to be done by me to defeat the light enemys
    }
}

uint16_t adc_get_lsens()
{
    return lsens_val;
}
