/*
 * btn.h
 *
 *  Created on: Jul 27, 2024
 *      Author: true
 */

#ifndef USER_SRC_BTN_H_
#define USER_SRC_BTN_H_



#define BTN_COUNT       2
#define BTN_DEBOUNCE    3   // debounce time in ~8ms increments

#define BTN_PUSH        (1 << 0)
#define BTN_HOLD        (1 << 1)
#define BTN_RELEASE     (1 << 2)
#define BTN_IGNORE      (1 << 3)



typedef struct Btn {
    uint8_t _mask;
    uint8_t _pintype;
    uint16_t _count;             // held counts
    uint16_t hold;              // initial hold
    uint16_t repeat;            // repeated hold
    void (*cb_push)(uint8_t);
    void (*cb_hold)(uint8_t);
    void (*cb_release)(uint8_t);
} Btn;



extern struct Btn btn[BTN_COUNT];



void btn_init();
void btn_poll();



#endif /* USER_SRC_BTN_H_ */
